// Copyright (c) 2000,2001
// Naknan, Inc.
// All Rights Reserved
// $Id: OPC.cpp,v 1.1 2001/07/05 18:16:44 james Exp $

#include "stdafx.h"

#include <jni.h>

#include "opcda.h"
#include "opc_ae.h"
#include "JNISink.h"
#include "com_naknan_example_opc_Opc.h"

const char* host_name = NULL;
const char* server_name = NULL;

CLSID clsid;
IMalloc *pIMalloc;
IClassFactory *factory;
IOPCEventServer *ae_server;

IUnknown *objserver;
IUnknown *objsubscription;

LPCONNECTIONPOINT  cp;
LPCONNECTIONPOINTCONTAINER cpc;

JNISink *iopces;

DWORD cookie;
DWORD revisedMaxSize;
DWORD revisedBufferTime;

OPCHANDLE handle = 1001;

WCHAR * WSTRFromSBCS(const char *buf, IMalloc *pmem)
{
	int length, i;
	WCHAR *temp;
	length = strlen(buf) + 1;

	if (pmem)
		temp = (WCHAR*)pmem->Alloc(sizeof(WCHAR) * (strlen(buf) + 1));
	else
		temp = new WCHAR[strlen(buf) + 1];

	if (temp)
		for (i = 0; i < length; i++)
			temp[i] = (WCHAR)buf[i];

	return temp;
} // WSTRFromSBCS

/*
 * Class:     com_naknan_example_opc_Opc
 * Method:    connect_p
 * Signature: (Lcom/naknan/example/opc/Opc;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_naknan_example_opc_Opc_connect_1p
  (JNIEnv *env, jobject, jobject callback)
{
	HRESULT result;

	result = CLSIDFromProgID(WSTRFromSBCS(server_name, pIMalloc), &clsid);

	if (FAILED(result))
	{
		return false;
	}

	result = CoGetClassObject(clsid, CLSCTX_LOCAL_SERVER, NULL,
								IID_IClassFactory, (void **)&factory);

	if (FAILED(result))
	{
		return false;
	}

	result = factory->CreateInstance(NULL, IID_IUnknown,(void **)&objserver);

	if (FAILED(result))
	{
		return false;
	}

	result = objserver->QueryInterface(IID_IOPCEventServer, (void**)&ae_server);

	if(FAILED(result))
	{
		return false;
	}

	result = ae_server->CreateEventSubscription(true, 0, 0, handle,
		IID_IOPCEventSubscriptionMgt, &objsubscription,
		&revisedBufferTime, &revisedMaxSize);

	if(FAILED(result))
	{
		return false;
	}

	((IOPCEventSubscriptionMgt *)objsubscription)->QueryInterface(&cpc);

	cpc->FindConnectionPoint(IID_IOPCEventSink, &cp);

	JavaVM *m_vm;
	env->GetJavaVM(&m_vm);

	iopces = new JNISink(m_vm, env->NewGlobalRef(callback));

	result = cp->Advise(iopces, &cookie);

	if(FAILED(result))
	{
		return false;
	}

	return true;
} // Java_com_naknan_example_opc_Opc_connect_1p

/*
 * Class:     com_naknan_example_opc_Opc
 * Method:    init_p
 * Signature: (Ljava/lang/String;Ljava/lang/String;)Z
 */
JNIEXPORT jboolean JNICALL Java_com_naknan_example_opc_Opc_init_1p
  (JNIEnv *env, jobject, jstring host, jstring server)
{
	HRESULT result;

	host_name = env->GetStringUTFChars(host, 0);
	server_name = env->GetStringUTFChars(server, 0);

	result = CoInitializeEx(NULL, COINIT_MULTITHREADED);

	if (FAILED(result))
	{
		return false;
	}

	result = CoGetMalloc(MEMCTX_TASK, &pIMalloc);

	if (FAILED(result))
	{
		CoUninitialize();
		return false;
	}

	return true;
} // Java_com_naknan_example_opc_Opc_init_1p